Subject: Re: [Alsa-devel] sound connector detection

From: Takashi Iwai <[email-masked]>
Date: Tue, 04 Jul 2006 17:55:25 +0200

At Mon, 03 Jul 2006 15:30:14 +0200,
Johannes Berg wrote:
> 
> 
> > I am not too happy with putting this kind of switches into input layer,
> > it should be reserved for "real" buttons, ones that user can explicitely
> > push or toggle (lid switch is on the edge here but it and sleep button
> > are used for similar purposes so it makes sense to have it in input layer
> > too). But "cable X connected" kind of events is too much [for input layer,
> > there could well be a separate layer for it]. If we go this way we'd have
> > to move cable detection code from network to input layer as well ;)
> 
> I sort of see the point. But I think it is indeed unfortunate that we
> have all these events scattered throughout. I could live with the
> current approach abusing the alsa mixer API, but there's little point in
> making that element user-visible. So maybe I just need some new alsa
> definitions here.

Such a control element doesn't have to be IFACE_MIXER if you want to
hide.  You can use IFACE_CARD, for example, for a card-specific
element but not belonging to the mixer component.

> Although, come to think of it, a daemon keeping the mixer open blocks
> unloading the module. I suppose I'd rather have it the other way around
> like the eventdev system does -- the device goes away and all reads to
> it fail.

That's true.  OTOH, invoking a command at each time isn't always a
good solution, depending on the event-frequency and heaviness.

Takashi